using System;
using Castle.DynamicProxy;

public class MyClass
{
	public static void Main()
	{
		try
		{
			WL(Environment.CurrentDirectory);
			WL("现在是我的代理在运行");
			A realA = new ProxyClass() as A;
			realA.DoSomething();
			
			WL("现在是Castle的代理在运行");
			ProxyGenerator generator = new ProxyGenerator();
			object proxy = generator.CreateClassProxy(typeof(RealA), new ProxyInterceptor());
			(proxy as RealA).DoSomething();
		}
		catch(Exception eX)
		{
			WL(eX.Message);
			WL(eX.StackTrace);
		}
		
		RL();
	}
	
	#region Helper methods

	private static void WL(object text, params object[] args)
	{
		Console.WriteLine(text.ToString(), args);	
	}
	
	private static void RL()
	{
		Console.ReadLine();	
	}
	
	private static void Break() 
	{
		System.Diagnostics.Debugger.Break();
	}

	#endregion
}