using System;
using System.Collections;
using Castle.DynamicProxy;

public class ProxyInterceptor:StandardInterceptor
{
	protected override void PostProceed(IInvocation invocation, ref object returnValue, params object[] arguments)
	{
		System.Console.WriteLine("Now i'm endding " + invocation.Method.Name);
		base.PostProceed(invocation, ref returnValue, arguments);
	}
	protected override void PreProceed(IInvocation invocation, params object[] args)
	{
		System.Console.WriteLine("Now i'm starting " + invocation.Method.Name);
		base.PreProceed(invocation, args);
	}
}